import object        
        
        
#
# Derive your own class from the singleton, and you will only ever get
# a single instance of it.
#
# note however, that this causes a cyclic reference 
#

class singleton(object.base):
    class __class__:
        def __init__(cl, name, bases=None, dict=None):
            cl.instance = None

        def __new__(cl, *args, **kw):
            i = cl.instance
            if i:
                if cl.__dict__.has_key('__init__'):
                    del cl.__dict__['__init__']
            else:
                super = object.base.__class__._
                i =  super.__new__(cl)
                cl.instance = i
            return i


class session(singleton):
    def __init__(self):
        self.value = 10

	
class my_session(session):
    def __init__(self):
        self.other = 20


            
s1 = session()
s2 = my_session()
s3 = session()
s4 = my_session()

print s1, s2
print s3, s4
