#
# Meta-class can also have their attribute access methods overidden.
#

import object

class foo(object.base):
    a = 10
    
    def __init__(self):
	print 'foo.__init__', self

    class __class__:
	a = 20
	
	def __getattr__(cl, name):
	    print '__getattr__', name
	    raise AttributeError

	def __setattr__(cl, name, value):
	    print '__setattr__', name, value
	    
	def __delattr__(cl, name):
	    print '__delattr__', name

print 'foo.a=', foo.a
f = foo()
print 'f.a=', f.a
d = {foo: 10}
print d
print f

foo.some_attr = 10	    
del foo.some_attr
try:
    a = foo.some_attr 
except AttributeError:
    pass

